/* tde51r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int de51r_c(U_fp, int *, float *, float *, float *, float *,
                       float *, int *, int *, float *, int *, float *,
                       float *, int *);
    static int ider, imax, ierr;
    extern int f_c();
    static float h__;
    static int i__, n;
    static float x, y[150], delty[150], ck[3], cn[3];
    static int ik;
    static float xk;
    static int nx;
    static float xn, yr[200], yx[150], rab[1650], eps;

    nx = 150;
    xn = 0.f;
    xk = 3.14159265359f;
    xk /= 2.f;
    cn[0] = 2.f;
    cn[1] = -1.f;
    cn[2] = 0.f;
    ck[0] = 1.f;
    ck[1] = 1.f;
    ck[2] = -1.f;
    imax = 4;
    eps = 1e-5f;
    ider = 1;
    i__1 = nx;
    for (i__ = 1; i__ <= i__1; ++i__) {
        yx[i__ - 1] = 1.5f;
/* L1: */
    }
    de51r_c((U_fp)f_c, &nx, &xn, &xk, cn, ck, &eps, &imax, &ider, yx, &ik,
            delty, rab, &ierr);

    printf("\n %5i \n", ik);
    printf("\n %5i \n", ierr);
    n = nx - 1;
    h__ = (xk - xn) / n;
    x = xn - h__;
    i__1 = nx;
    for (i__ = 1; i__ <= i__1; ++i__) {
        x += h__;
        y[i__ - 1] = (float)sin(x) + (float)cos(x) * 2.f;
        yr[i__ - 1] = yx[i__ - 1] - y[i__ - 1];

        printf("\n %16.7e %16.7e %16.7e %16.7e \n",
               x, yx[i__-1], y[i__-1], yr[i__-1]);
/* L2: */
    }
    return 0;
} /* main */

int f_c(float *fc, float *gc, float *rc, float *x, float *y, int *i__,
        float *rab)
{
    /* Builtin functions */
    double exp(double), cos(double), sin(double);

    /* Parameter adjustments */
    --rab;

    /* Function Body */
    *fc = *x * rab[*i__];
    *gc = (float)exp(-(*y));
    *rc = (*x * rab[*i__] - 2.f +
          (float)exp(-(*y)) * 2.f) * (float)cos(*x) -
          (*x * 2.f * rab[*i__] + 1.f -
          (float)exp(-(*y))) * (float)sin(*x);
    return 0;
} /* f_c */
